# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CloudAccountAwsRegionEnumerationSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'access_key_id': 'str',
        'secret_access_key': 'str',
        'cloud_account_id': 'str'
    }

    attribute_map = {
        'access_key_id': 'accessKeyId',
        'secret_access_key': 'secretAccessKey',
        'cloud_account_id': 'cloudAccountId'
    }

    def __init__(self, access_key_id=None, secret_access_key=None, cloud_account_id=None):  # noqa: E501
        """CloudAccountAwsRegionEnumerationSpecification - a model defined in Swagger"""  # noqa: E501
        self._access_key_id = None
        self._secret_access_key = None
        self._cloud_account_id = None
        self.discriminator = None
        if access_key_id is not None:
            self.access_key_id = access_key_id
        if secret_access_key is not None:
            self.secret_access_key = secret_access_key
        if cloud_account_id is not None:
            self.cloud_account_id = cloud_account_id

    @property
    def access_key_id(self):
        """Gets the access_key_id of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501

        Aws Access key ID. Either provide accessKeyId or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The access_key_id of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._access_key_id

    @access_key_id.setter
    def access_key_id(self, access_key_id):
        """Sets the access_key_id of this CloudAccountAwsRegionEnumerationSpecification.

        Aws Access key ID. Either provide accessKeyId or provide a cloudAccountId of an existing account.  # noqa: E501

        :param access_key_id: The access_key_id of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._access_key_id = access_key_id

    @property
    def secret_access_key(self):
        """Gets the secret_access_key of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501

        Aws Secret Access Key. Either provide secretAccessKey or provide a cloudAccountId of an existing account.  # noqa: E501

        :return: The secret_access_key of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._secret_access_key

    @secret_access_key.setter
    def secret_access_key(self, secret_access_key):
        """Sets the secret_access_key of this CloudAccountAwsRegionEnumerationSpecification.

        Aws Secret Access Key. Either provide secretAccessKey or provide a cloudAccountId of an existing account.  # noqa: E501

        :param secret_access_key: The secret_access_key of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._secret_access_key = secret_access_key

    @property
    def cloud_account_id(self):
        """Gets the cloud_account_id of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501

        Existing cloud account id. Either provide existing cloud account id, or accessKeyId/secretAccessKey credentials pair.  # noqa: E501

        :return: The cloud_account_id of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501
        :rtype: str
        """
        return self._cloud_account_id

    @cloud_account_id.setter
    def cloud_account_id(self, cloud_account_id):
        """Sets the cloud_account_id of this CloudAccountAwsRegionEnumerationSpecification.

        Existing cloud account id. Either provide existing cloud account id, or accessKeyId/secretAccessKey credentials pair.  # noqa: E501

        :param cloud_account_id: The cloud_account_id of this CloudAccountAwsRegionEnumerationSpecification.  # noqa: E501
        :type: str
        """

        self._cloud_account_id = cloud_account_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudAccountAwsRegionEnumerationSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudAccountAwsRegionEnumerationSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
